<?php
/*
  Author: Greg Feigenson
  File: add_problem.php
  Copyright: 2004-2005 Greg Feigenson
  
  This software is licensed under the BSD license.
  Please see attached license or www.opensource.org
  for details
*/
require('includes/header.inc.php');

if (isset($_POST['submitted']) /*== !null*/)
{
	if (isset($_POST['workorder_id']) /*!= null*/ && isset($_POST['description']) /*!= null*/)
	{
		if (isset($_POST['workorder_id']) && !is_numeric($_POST['workorder_id']))
		{
		     echo "<br><br><div align='center'>
		           <b><font color='red'>Invalid ticket ID! Please make sure you have entered a number</font></b>
			   <br><br>";
		}
		else
		{
			/* Clean up post vars */
			$work_order_id  = $_POST['workorder_id'];
			$description    = "'".$_POST['description']."'";
			
			/* Clean data */
			if (!$_POST['cost'] == null)
				$cost = "'".$_POST['cost']."'";
			else
				$cost = "NULL";
				
			if (!$_POST['notes'] == null)
				$notes = "'".$_POST['notes']."'";
			else
				$notes = "NULL";
				
			if (!$_POST['estimated_time'] == null)
				$estimated_time = "'".$_POST['estimated_time']."'";
			else
				$estimated_time = "NULL";
			
			/* Build and run query */
			$query = "INSERT INTO $tbl_problems
				  (work_order_id, cost, description, notes, estimated_time) 
				  VALUES ($work_order_id,$cost,$description,$notes,$estimated_time)";
			
			//include the db
		        include("includes/db.inc.php");
			@$result = pg_exec($query) or die("<b><font color='red'><div align='center'>Query failed: Invalid ticket id"); //standard PG query - @ surpresses pg_query's innate nature to provide debug info - we already know the problem is ref. integrity.
			 			//$result = pg_exec($query) or die("Query failed : " . pg_last_error($connection)); //debug - only uncomment when commenting out the top line and only in case of error
			if ($result)
			{
				echo "<div align='center'>
				      <br><br>
				      
				      <b>Problem added successfully!</b>
				      
				      </div>";
			}
			else
			{
				echo "<div align='center'>
				      <br><br>
				      
				      <b><font color='red'>Error adding problem, please make 
				      sure all required fields (with * next to them) are filled 
				      out correctly and the referenced workorder exists</b></font>
				      
				      </div>";
			}
		}
			  
	}
	else
	{
		echo "<div align='center'>
		      <br><br>
		      
		      <b><font color='red'>Error adding problem, please make 
		      sure all required fields (with * next to them) are filled 
		      out</b></font></div>";
	}
	
	printForm();
}
else
	printForm();
	
function printForm()
{
	$wo_id = "";
	
	if (isset($_GET['wo']))
		$wo_id = $_GET['wo']; //grab ID if passed from new work order
	
	echo "<DIV align='center'> <H1>Add a problem to the ticket</H1>
				<i>(Please see work order list for a valid ID)</i><br><br>";
	
	echo "<form name='input' action='add_problem.php' method='POST'>
	      <br><br>
	
	      <table border=1>
	       
	      <input type='hidden' name='submitted' value='yes'>
	       
	      <tr><td>*Ticket ID*:</td>
	      <td><input type='text' name='workorder_id' value=$wo_id></td></tr>
	      
	      <tr><td>Cost:</td>
	      <td><input type='text' name='cost'></td></tr>
	      
	      <tr><td>Estimated Time to Fix:</td>
	      <td><input type='text' name='estimated_time'></td></tr>
	       
	      </table>
	       
	      <BR>
	      *Problem Description*:<br>
	      <textarea rows='10' cols='30' name='description'> </textarea>
	      <BR><BR>
	       
	      <BR>
	      Notes:<br>
	      <textarea rows='10' cols='30' name='notes'> </textarea>
	      <BR><BR>
	       
	      <BR><BR>
	
	      <input type='submit' value='Add problem'>
	
	      </form>";
}

require('includes/footer.inc.php');
?>